import java.net.SocketException;

import java.io.*;
import java.net.*;
import java.nio.Buffer;
import java.util.*;
import static java.lang.System.out;

public class ListNetworkInterfaces {

	/**
	 * @param args
	 */

	public static void main(String args[]) throws SocketException {
		Enumeration<NetworkInterface> nets = NetworkInterface
				.getNetworkInterfaces();
		for (NetworkInterface netint : Collections.list(nets))
			displayInterfaceInformation(netint);
	}

	static void displayInterfaceInformation(NetworkInterface netint)
			throws SocketException {
		out.printf("Description : %s\n", netint.getDisplayName());
		out.printf("Nom: %s\n", netint.getName());
		Enumeration<InetAddress> inetAddresses = netint.getInetAddresses();

		for (InetAddress inetAddress : Collections.list(inetAddresses)) {
			out.printf("Adresse Internet : %s\n", inetAddress);
		}
		out.printf("En marche ? %s\n", netint.isUp());
		out.printf("Loopback? %s\n", netint.isLoopback());
		out.printf("Point a Point? %s\n", netint.isPointToPoint());
		out.printf("Supporte multicast? %s\n", netint.supportsMulticast());
		out.printf("Virtuelle ? %s\n", netint.isVirtual());

		byte[] adresseMaterielle = netint.getHardwareAddress();
		StringBuffer sb = new StringBuffer();
		
		out.printf("Adressse materielle : %s\n",
				Arrays.toString(adresseMaterielle));

		out.printf("Unite Maximum de Transmission (MTU): %s\n", netint.getMTU());
		out.printf("\n");
	}

}
