package asynchronous;
import java.io.IOException;
import java.net.InetSocketAddress;
import java.nio.ByteBuffer;
import java.nio.channels.AsynchronousServerSocketChannel;
import java.nio.channels.AsynchronousSocketChannel;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;


public class Serveur {
	private boolean estActif =true;
	public static void main(String[] args) throws IOException, InterruptedException, ExecutionException {
		new Serveur().go();
	}

	private void go() throws IOException, InterruptedException, ExecutionException {
		 AsynchronousServerSocketChannel serverChannel = AsynchronousServerSocketChannel.open();
		 InetSocketAddress adresseServeur = new InetSocketAddress("localhost", 3883);
		 serverChannel.bind(adresseServeur);
		 System.out.println("Serveur en coute sur le port: " + adresseServeur.getPort());
		 System.out.println("Attente de connexion de clients... ");
		 
		 Future<AsynchronousSocketChannel> acceptResult = serverChannel.accept();
		 AsynchronousSocketChannel clientChannel =  acceptResult.get();
		 System.out.println("Messages du client : ");
		 
		 if ((clientChannel != null) && (clientChannel.isOpen())) {
			 while (estActif) {
				 ByteBuffer buffer = ByteBuffer.allocate(128);
				 Future<Integer> result = clientChannel.read(buffer);
				 while (! result.isDone()) {
					 //ne fait rien
				 }
				 buffer.flip();
				 String message = new String(buffer.array()).trim();
				 System.out.println(message);
				 if( message.equals("Au revoir")) estActif= false;
				buffer.clear();
			 }			 
			 }
		 clientChannel.close();
		 serverChannel.close();			 
		 }
	}

