package nio.selecteur;

/* Annick Fron
 * Serveur non bloquant avec un selecteur
 */

import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.ServerSocket;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;
import java.util.Iterator;
import java.util.Set;

public class Serveur {
private static int BUFFER_SIZE= 1024;

	public static void main(String[] args) {
		try {
			Selector selector= Selector.open() ;
			ServerSocketChannel serverSocketChannel = ServerSocketChannel.open() ;
			serverSocketChannel.configureBlocking(false) ; // on prcise le mode asynchrone
			int port = 6789 ;
			ServerSocket serveurSocket=serverSocketChannel.socket() ;
			InetSocketAddress address = new InetSocketAddress(port) ;
			serveurSocket.bind(address);
			selector = Selector.open();
			SelectionKey serverKey=serverSocketChannel.register(selector,
			      SelectionKey.OP_ACCEPT);
			// traitement des requetes
			boolean serveurActif= true;
			while(serveurActif) {
				  int count = selector.select();
//				 Pas de clients 
				  if (count == 0) {continue; }
				  Set keySet = selector.selectedKeys();
				  Iterator itor = keySet.iterator();
//				 Itration sur les clients
				  while (itor.hasNext()) {
				     SelectionKey selectionKey = (SelectionKey) itor.next();
//				 traitement de la demande
				     if (selectionKey.isAcceptable()) { 
				    	 ServerSocketChannel ssc = (ServerSocketChannel)selectionKey.channel(); 
				    	 SocketChannel sc = ssc.accept(); 
				    	 sc.configureBlocking( false ); 
				    	 SelectionKey newKey = sc.register( selector, SelectionKey.OP_READ ); 
				    	 itor.remove() ;
				    	
				  } else if (selectionKey.isReadable()) { 
//					 Lecture de la donne 
					 SocketChannel socketChannel = (SocketChannel)selectionKey.channel(); 
					 ByteBuffer sharedBuffer = ByteBuffer.allocateDirect(BUFFER_SIZE);
					 sharedBuffer.clear();
					 int bytes = -1;
					 while ( (bytes = socketChannel.read(sharedBuffer)) > 0) {
					     System.out.println("Lecture...");
					     sharedBuffer.flip();
//					 echo du code lu dans la socket en criture
					     while (sharedBuffer.hasRemaining()) {
					        System.out.println("Ecriture...");
					        socketChannel.write(sharedBuffer);
					      }
					     sharedBuffer.clear();}
					selectionKey.cancel();
					socketChannel.close();
					} 


				  
				  }


				  }
		} catch (IOException e) {
		
			e.printStackTrace();
		}

	}

}
